import os,sys,traceback

"""

class JPlugin:
    __author__="undefined"
    __version__="undefined"

    def __init__(self,id,path):
        self.id = id
        self.path=path
"""
import gettext,locale
import gtk

#~ from datetime import datetime

class JPlugins:
    path = "plugins"
    outputFullError=True

    def __init__(self):
        """ Initialize the plugins ...
            will create a list of instance in self.__plugins, from
            the plugins which sit in the path __path
        """
        self.__plugins = []

        for id in os.listdir(JPlugins.path):
            path = JPlugins.path+"/"+id
            if id[0]!="." and os.path.isdir(path):
                namespace = path.replace("/",".")

                try:
                    isTrans = gettext.translation("plugin",path+"/po",languages=[locale.getdefaultlocale()[0]],fallback=True)
                except IOError:
                    isTrans = False
                    print "*WARNING* : NO TRANS FOR PLUGIN",id



                try:
                    # import the module plugin
                    module=__import__(namespace,[],[],["Plugin"])

                    if isTrans:
                        # needed for the _ in the __init__ plugin (menuentry traduction)
                        module.__dict__["_"] = lambda s : gettext.translation("plugin","po",languages=[locale.getdefaultlocale()[0]],fallback=True).ugettext(s)
                    else:
                        module.__dict__["_"] = lambda x : x


                    # create an instance
                    instance = module.Plugin(id,path)

                    #add to the list
                    self.__plugins.append(instance)
                except:
                    self.__plugError("in creation of '%s'"%id)

    def __plugError(self,m=""):
        print >>sys.stderr,"PLUGIN ERROR : %s" % m
        if JPlugins.outputFullError:
            print >>sys.stderr,'-'*60
            traceback.print_exc(file=sys.stderr)
            print >>sys.stderr,'-'*60

    def show(self,ln,idx):
        """
        find the first plugin which have the method showEntry
        and call it by passing ln and idx
        """
        find=False
        for instance in self.__plugins:
            if hasattr(instance,"showEntry"):
                find=True
                precPath = os.getcwdu()
                os.chdir(instance.path)
                try:
                    instance.showEntry(ln,idx)
                except:
                    self.__plugError("%s.showEntry() is bugged "%instance.id)
                os.chdir(precPath)

        if not find:
            print "no plugin to show"

    def menuEntries(self,l=[]):
        """ will return a ordered list of "menu entries" of plugins
            [ ( order, label, alter, callback ),  ... ]

            "l" can be the present selection of photonode
        """
        # get all the menuentries of plugins in --> a
        a=[]
        for instance in self.__plugins:
            precPath = os.getcwdu()
            os.chdir(instance.path)
            try:
                menus = instance.menuEntries(l)
            except:
                self.__plugError("%s.menuEntries() is bugged "%instance.id)
                menus=[]
            os.chdir(precPath)

            for ordre,label,alter,callback,img in menus:
                a.append( (ordre,label,alter,callback,img,instance.path) )


        # sort them, according the "order" value
        a.sort( cmp=lambda a,b: cmp(a[0],b[0]) )

        # remakes the order (from 0), and place callback of callback, from a --> b
        b=[]
        for ord,nom,alter,callback,img,path in a:
            pathImg = img and os.path.join(path,img) or None
            b.append( (len(b),nom,alter,self.__callMenuEntry(callback,path),pathImg ))
        return b

    def __callMenuEntry(self,callback,path):
        """ callBack of callback .. to be able to control what appends while
            the call of the original callback
        """
        def myCallBack(*a,**k):

            precPath = os.getcwdu()
            os.chdir(path)
            try:
                ret=callback(*a,**k)
            finally:
                os.chdir(precPath)
            return ret
        return myCallBack

    def __repr__(self):
        m="Plugins : %d\n" % len(self.__plugins)
        for i in self.__plugins:
            m+= "\tPlugin '%s %s' from %s: %s \n" % (i.id,i.__version__,i.__author__,i.__doc__)
        return m

if __name__=="__main__":
    j=JPlugins()
    for id,nom,alter,callback in j.menuEntries():
        print ">>>>>>>>>>> %d. '%s' (mod:%s)" % (id,nom,alter), callback
