#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

from __main__ import JPlugin

import os,time,shutil

class Plugin(JPlugin):
    """Plugin pour exporter les photos selectionnes vers un repertoire
    (possibilite de les redimensionner au passage)"""

    __author__ = "manatlan"
    __version__ = "1.1"

    def menuEntries(self,l):
        return [(3000,_("Export to"),False,self.export,None)]

    def export(self,list):
        from export import Windowexport

        window_export = Windowexport()

        window_export.entry.set_text( self.conf["path"] or "" )
        window_export.notebook1.set_current_page(self.conf["mode"] or 0)
        window_export.hscale_quality.set_value( float(self.conf["quality"] or 100) )
        window_export.hscale_size.set_value( float(self.conf["size"] or 100))
        window_export.cb_keepFolder.set_active( (self.conf["keepFolder"] or 0)==1 )

        ret=window_export.loop()[0]
        if ret:
            path,mode,qual,size,keepFolder = ret
            self.conf["path"]=path
            self.conf["mode"]=mode
            self.conf["quality"]=qual
            self.conf["size"]=size
            self.conf["keepFolder"]=keepFolder

            del(window_export)

            if os.path.isdir(path):
                dir = unicode( path + "/Jbrout " + time.strftime("%Y-%m-%d, %H-%M-%S") )
                os.mkdir(dir)

                try:
                    for pnode in list:
                        self.showProgress( list.index(pnode), len(list) , _("Exporting") )
                        file = pnode.file

                        if keepFolder:
                            ddir =os.path.join(dir,pnode.folderName)
                            if not os.path.isdir(ddir):
                                os.mkdir(ddir)
                        else:
                            ddir =dir

                        if mode==1: # reduced
                            pnode.copyTo(ddir, resize=( float(size/100),qual) )
                        else:
                            pnode.copyTo(ddir)
                finally:
                    self.showProgress()
            else:
                self.MessageBox(_("The selected path doesn't exists !"))

        return False
